SystemOrganization addCategory: #TusLibros!

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 20:17'!
aBook
	^	Object new! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 20:50'!
aCartWith: aCatalog  
	^Cart with: aCatalog ! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 20:36'!
aCatalog
	^Set new! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 20:34'!
anEmptyCart
	^	Cart with: (self aCatalog)! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 20:50'!
anEmptyCatalog
	^ Set new! !

!TusLibrosTest methodsFor: 'cart tests' stamp: 'FacundoPippia 5/29/2013 20:56'!
testAddProductShouldFailIfProductIsNotInCatalog
	| cart |
	
	cart := self aCartWith: self anEmptyCatalog.
	
	self should: [cart add: self aBook] 
		raise: Error 
		withExceptionDo: [ :anError |
			self assert: anError messageText = 'Product is not in catalog'.
			self assert: cart isEmpty ]! !

!TusLibrosTest methodsFor: 'cart tests' stamp: 'FacundoPippia 5/29/2013 20:18'!
testCartShouldBeEmptyAfterCreation

	self assert: self anEmptyCart isEmpty

 ! !

!TusLibrosTest methodsFor: 'cart tests' stamp: 'FacundoPippia 5/29/2013 21:24'!
testCartShouldContainAProductThatWasAdded

	| aCart book|
	book := self aBook.
	aCart := self aCartWith: (Set with: book).
	aCart add: book.

	self assert: (aCart contains: book).! !

!TusLibrosTest methodsFor: 'cart tests' stamp: 'FacundoPippia 5/29/2013 21:20'!
testCartShouldContainTheAmountOfBooksAdded
	"comment stating purpose of message"

	| cart book anotherBook catalog|
	book := self aBook.
	anotherBook := self aBook.
	catalog := (Set with: book with: anotherBook).
	cart := self aCartWith: catalog.
	cart add: book.
	cart add: anotherBook.
	self assert: (cart productCount = 2).! !

!TusLibrosTest methodsFor: 'cart tests' stamp: 'FacundoPippia 5/29/2013 21:21'!
testCartShouldNotBeEmptyAfterAddingABook
	"comment stating purpose of message"
	|cart book catalog|
	book := self aBook.
	catalog := (Set with: book).
	cart := self aCartWith: (catalog).
	cart add: book.
	self deny: (cart isEmpty).! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 22:00'!
testCheckoutShouldFailIfCartIsEmpty
	| emptyCart cashier |
	
	cashier := self aCashier.
	emptyCart := self anEmptyCart.
	
	self should: [ cashier checkout: emptyCart ] 
		raise: Error 
		withExceptionDo: [  ]! !

Object subclass: #Cart
	instanceVariableNames: 'products catalog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cart class methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 20:31'!
with: aCatalog
	^self new initializeWith: aCatalog ! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 20:55'!
add: aProduct 
	(catalog includes: aProduct) ifFalse: [ Error signal: 'Product is not in catalog' ].
	products add: aProduct.
	
! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 21:09'!
contains: aProduct
	^ products includes: aProduct.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 20:21'!
initialize
	products := Bag new.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 20:25'!
initializeWith: aCatalog 
	products := Bag new.
	catalog := aCatalog! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 20:21'!
isEmpty
	^ products isEmpty.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 20:30'!
productCount
	^ products size.! !
